/*
 genx realtime terrain visualization
 (c) 2004-2005 Witold Bolt <ja@hope.art.pl>

 file: minimap.c

 mini map handling - broken for now!

*/

#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glext.h>

#include "SDL.h"

#include "genx.h"
#include "heightmap.h"
#include "minimap.h"

static Uint32 minimapTexture;

SDL_bool minimap_mode = SDL_FALSE;

void initMiniMap(Uint32 size)
{
 Uint32 i,j;
 Uint8 color[3];
 Uint8 *minimap;

 minimap = (Uint8*)malloc(3*size*size*sizeof(Uint8));

 for(i=0;i<3*size;i+=3)
  for(j=0;j<size;j++)
  {
   getHeightPointColor8(i/3,j,color);
   minimap[i+size*j]=color[0];
   minimap[i+size*j+1]=color[1];
   minimap[i+size*j+2]=color[2];
  }
  glGenTextures(1,&minimapTexture);
  glBindTexture(GL_TEXTURE_2D,minimapTexture);
  glTexImage2D(GL_TEXTURE_2D,0,3,size,size,0,GL_RGB,GL_UNSIGNED_BYTE,minimap);
  free(minimap);
}

void putMinimap()
{
  glBindTexture(GL_TEXTURE_2D,minimapTexture);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  glBegin(GL_QUADS);
//        glColor4f(1.0f,1.0f,1.0f,1.0f);
 	glTexCoord2f(0.0f, 0.0f);
 	glVertex2f(0.0f,0.0f);
 	
 	glTexCoord2f(1.0f,0.0f);
 	glVertex2f(100.0f,0.0f);
 	
 	glTexCoord2f(1.0f,1.0f);
 	glVertex2f(100.0f,100.0f);

 	glTexCoord2f(0.0f,1.0f);
 	glVertex2f(0.0f,100.0f);
 glEnd();
}


