/*
 genx realtime terrain visualization
 (c) 2004-2005 Witold Bolt <ja@hope.art.pl>

 file: vector.c

 simple 3d-vector math

 some code inspired by the glm library - but it's all quie simple :)
 glm (opengl math library) written by: Markus Ilmola
 and found here: http://personal.inet.fi/koti/markus.ilmola/glm.htm
 
*/

#include <math.h>
#include "vector.h"

 void crossProduct(float result[3], float v1[3], float v2[3])
{
  result[0]=v1[1]*v2[2]-v1[2]*v2[1];
  result[1]=v1[2]*v2[0]-v1[0]*v2[2];
  result[2]=v1[0]*v2[1]-v1[1]*v2[0];
}
/* returns result vector made from two points: p1, p2*/
 void makeVector(float result[3], float p1[3], float p2[3])
{
  result[0]=p2[0] - p1[0];
  result[1]=p2[1] - p1[1];
  result[2]=p2[2] - p1[2];
}

/* returns vector lenght */
 float vectorLenght(float vector[3])
{
 return sqrt(pow(vector[0],2) + pow(vector[1],2) + pow(vector[2],2));
}

/* normalize vecotr */
 void reduceToUnit(float vector[3])
{
 float lenght;
 lenght = vectorLenght(vector);

 vector[0] = vector[0] / lenght;
 vector[1] = vector[1] / lenght;
 vector[2] = vector[2] / lenght;
}

